package com.casic.missiles.service.meter;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.casic.missiles.dto.BaseApprovalSubmitRequest;
import com.casic.missiles.dto.ReturnDTO;
import com.casic.missiles.dto.flowable.ApprovalDeleteRequest;
import com.casic.missiles.dto.meter.*;
import com.casic.missiles.model.meter.MeterTrainPlan;

import java.util.List;

/**
 * <p>
 * 计量管理-培训管理-培训计划表 服务类
 * </p>
 *
 * @author wangpeng
 * @since 2022-11-23
 */
public interface IMeterTrainPlanService extends IService<MeterTrainPlan> {

    Page<MeterTrainPlan> listPage(Page<MeterTrainPlan> page, TrainPlanListRequest request);

    ReturnDTO<TrainPlanSaveResponse> saveTrainPlan(MeterTrainPlan trainPlan);

    ReturnDTO submitTrainPlan(BaseApprovalSubmitRequest request);

    ReturnDTO updateTrainPlan(MeterTrainPlan meterTrainPlan);

    ReturnDTO deleteTrainPlan(Long id);

    ReturnDTO deleteBatchTrainPlan(List<Long> ids);

    ReturnDTO<TrainPlanDetailResponse> trainPlanDetail(Long id);

    ReturnDTO<TrainPlanDetailResponse> planQrCode(Long id);

    ReturnDTO<TrainPlanDetailResponse> signIn(TrainPlanSignInRequest trainPlanSignInRequest);

    List<MeterTrainPlan> planList(TrainPlanListRequest request);

    ReturnDTO draftUpdate(MeterTrainPlan trainPlan);

    List<TrainPlanApprovalListResponse> approvalListPage(Page<TrainPlanApprovalListResponse> page, TrainPlanApprovalListRequest request);

    ReturnDTO approvalDelete(ApprovalDeleteRequest request);

    ReturnDTO failUpdate(MeterTrainPlan trainPlan);
}
